LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
-- keine Ports
END testbench;

ARCHITECTURE behavior OF testbench IS 
-- entity sr_adc2 is
--     Port ( cs      : in    STD_LOGIC;   -- start with setting cs high
--            ss      : in    STD_LOGIC;   -- single shot (high) or free running (low)
--            i_clock : in    STD_LOGIC;   -- system clock
--            o_clock : inout STD_LOGIC;   -- clock line to ADC, will be internal clock too
--            aconv   : inout STD_LOGIC;   -- trigger to start conversion
--            adata   : in    STD_LOGIC;   -- serial data from ADC
--            nWE     : out   STD_LOGIC;   -- negated write enable (memory)
--            data    : out   STD_LOGIC_VECTOR (15 downto 0);   -- result data from ADC
--            addr    : out   STD_LOGIC_VECTOR (20 downto 0));  -- self incrementing memory address in free running mode
-- end sr_adc2;

   COMPONENT sr_adc2 
      Port ( cs      : in  STD_LOGIC;
             ss      : in  STD_LOGIC;
             i_clock : in  STD_LOGIC;
             o_clock : inout STD_LOGIC;
             aconv   : inout STD_LOGIC;
             adata   : in  STD_LOGIC;
             nWE     : out  STD_LOGIC;
             data    : out  STD_LOGIC_VECTOR (15 downto 0);
             addr    : out  STD_LOGIC_VECTOR (20 downto 0)
           );
   END COMPONENT;

   -- Signale zur Verdrahtung
   -- Inputs
   SIGNAL cs      : std_logic := '0';
   SIGNAL ss      : std_logic := '0';
   SIGNAL i_clock : std_logic := '0';
   SIGNAL adata   : std_logic := '0';

   -- Outputs
   SIGNAL o_clock : std_logic := '0';
   SIGNAL aconv   : std_logic := '0';
   SIGNAL nWE     : std_logic := '0';
   SIGNAL data    : std_logic_vector(15 downto 0);
   SIGNAL addr    : std_logic_vector(20 downto 0);
BEGIN
 
  -- deine Schaltung anschliessen
  uut: sr_adc2 PORT MAP(
         cs => cs,
         ss => ss,
         i_clock => i_clock,
         adata => adata,
         o_clock => o_clock,
         aconv => aconv,
         nWE => nWE,
         data => data,
         addr => addr);

  -- Simulations-Signale erzeugen, hier beginnt deine Arbeit...
  tb : PROCESS
  BEGIN
     i_clock <= '1';
     wait for 10 ns;

     cs <= '1';
     ss <= '1';
     i_clock <= '0';
     wait for 10 ns;

     -- Takt 1
     i_clock <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 2
     i_clock <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 3
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 4
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 5
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 6
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 7
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 8
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 9
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 10
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 11
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 12
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 13
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 14
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 15
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 16
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 17
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 18
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 19
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 20
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 21
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 22
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 23
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 24
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 25
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 26
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 27
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 28
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 29
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 30
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 31
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 32
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 33
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 34
     i_clock <= '1';
     adata   <= '0';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 35
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 36
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 37
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 38
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 39
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 40
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 41
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 42
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 43
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 44
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 45
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 46
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 47
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 48
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 49
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 50
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 51
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 52
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 53
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 54
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 55
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 56
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 57
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 58
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 59
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

     -- Takt 60
     i_clock <= '1';
     adata   <= '1';
     wait for 10 ns;

     i_clock <= '0';
     wait for 10 ns;

  END PROCESS;
END;
